


#include "disp.h"
#include "projectconfig.h"
//#include "typedefs.h"

//volatile unsigned char Font=0;


/* SSPSR - bit definitions. */


  unsigned char CharWidth = 8;  // How many pixel wide (real pixel data, not including any empty pixel for frame)
  unsigned char CharHeight = 14;  // How many pixel heigth (real pixel data, not including any empty pixel for frame)
  unsigned char CellWidth = 6;  // How many pixel wide including empty pixels, if you like to get more space between the characters rise this num
  unsigned char CellHeight = 9;  
  unsigned char rc = 0;  //lcd row_counter
/*----------------------*/
unsigned int init_data[] =
      { 
    0xFDFD, 0xFDFD,
    // pause
 
    0xEF00, 0xEE04, 0x1B04, 0xFEFE, 0xFEFE, 
    0xEF90, 0x4A04, 0x7F3F, 0xEE04, 0x4306,
    // pause
 
    0xEF90, 0x0983, 0x0800, 0x0BAF, 0x0A00, 
    0x0500, 0x0600, 0x0700, 0xEF00, 0xEE0C, 
    0xEF90, 0x0080, 0xEFB0, 0x4902, 0xEF00, 
    0x7F01, 0xE181, 0xE202, 0xE276, 0xE183, 
    0x8001, 0xEF90, 0x0000 
    }; 
  
/*----------------------------------------------------------*\
 | Delay                                                    |
\*----------------------------------------------------------*/
void  Delay(unsigned int  dly) {
  unsigned int  i;

  for(; dly>0; dly--) 
    for(i=0; i<10000; i++);   //
  }
/*----------------------------------------------------------*\
 |SSP Initialize                                       |
\*----------------------------------------------------------*/
/**************************************************************************/
void sspInit (uint8_t portNum, sspClockPolarity_t polarity, sspClockPhase_t phase)
{
  gpioInit();

  if (portNum == 0)
  {
    /* Reset SSP */
    SCB_PRESETCTRL &= ~SCB_PRESETCTRL_SSP0_MASK;
    SCB_PRESETCTRL |= SCB_PRESETCTRL_SSP0_RESETDISABLED;
  
    /* Enable AHB clock to the SSP domain. */
    SCB_SYSAHBCLKCTRL |= (SCB_SYSAHBCLKCTRL_SSP0);
  
    /* Divide by 1 (SSPCLKDIV also enables to SSP CLK) */
    SCB_SSP0CLKDIV = SCB_SSP0CLKDIV_DIV1;  // 1 = 4.0MHz
  
    /* Set P0.8 to SSP MISO */
    IOCON_PIO0_8 &= ~IOCON_PIO0_8_FUNC_MASK;
    IOCON_PIO0_8 |= IOCON_PIO0_8_FUNC_MISO0;
  
    /* Set P0.9 to SSP MOSI */
    IOCON_PIO0_9 &= ~IOCON_PIO0_9_FUNC_MASK;
    IOCON_PIO0_9 |= IOCON_PIO0_9_FUNC_MOSI0;

    /* Set 2.11 to SSP SCK (0.6 and 0.10 can also be used) */ 
    #ifdef CFG_SSP0_SCKPIN_0_10
    IOCON_SCKLOC = IOCON_SCKLOC_SCKPIN_PIO0_10;//IOCON_SWCLK_PIO0_10;//SCKLOC_IOCON_SWCLK_PIOO_10;//IOCON_SCKLOC_SCKPIN_PIO0_10; 
    //IOCON_PIO0_10 = IOCON_PIO0_10_FUNC_SCK0;  // IOCON_SCK0_LOC-->IOCON_SWCLK_PIO0_10
    #endif

    /* Set 0.6 to SSP SCK (2.11 and 0.10 can also be used) */ 
    #ifdef CFG_SSP0_SCKPIN_0_6
    IOCON_SCKLOC = IOCON_SCKLOC_SCKPIN_PIO0_6; 
    IOCON_PIO0_6 = IOCON_PIO0_6_FUNC_SCK;
    #endif

    /* Set P0.2/SSEL to GPIO output and high */
    IOCON_PIO0_2 &= ~IOCON_PIO0_2_FUNC_MASK;
    IOCON_PIO0_2 |= IOCON_PIO0_2_FUNC_GPIO;
    gpioSetDir(disp_CSPORT, disp_CSPIN, 1);
    gpioSetValue(disp_CSPORT, disp_CSPIN, 1);
    gpioSetPullup(&IOCON_PIO0_2, gpioPullupMode_Inactive);  // Board has external pull-up
  
    /* If SSP0CLKDIV = DIV1 -- (PCLK / (CPSDVSR × [SCR+1])) = (72,000,000 / (2 x [8 + 1])) = 4.0 MHz */
    uint32_t configReg = ( SSP_SSP0CR0_DSS_8BIT   // Data size = 8-bit
                  | SSP_SSP0CR0_FRF_SPI           // Frame format = SPI
                  | SSP_SSP0CR0_SCR_8);           // Serial clock rate = 8
  
    // Set clock polarity
    if (polarity == sspClockPolarity_High)
      configReg |= SSP_SSP0CR0_CPOL_HIGH;     // Clock polarity = High between frames
    else
      configReg &= ~SSP_SSP0CR0_CPOL_MASK;    // Clock polarity = Low between frames
  
    // Set edge transition
    if (phase == sspClockPhase_FallingEdge)
      configReg |= SSP_SSP0CR0_CPHA_SECOND;   // Clock out phase = Trailing edge clock transition
    else
      configReg &= ~SSP_SSP0CR0_CPHA_MASK;    // Clock out phase = Leading edge clock transition
  
    // Assign config values to SSP0CR0
    SSP_SSP0CR0 = configReg;
  
    /* Clock prescale register must be even and at least 2 in master mode */
    SSP_SSP0CPSR = SSP_SSP0CPSR_CPSDVSR_DIV2;
  
    /* Clear the Rx FIFO */
    uint8_t i, Dummy=Dummy;
    for ( i = 0; i < SSP_FIFOSIZE; i++ )
    {
      Dummy = SSP_SSP0DR;
    }
  
    /* Enable the SSP Interrupt */
    NVIC_EnableIRQ(SSP_IRQn);
  
    /* Set SSPINMS registers to enable interrupts
     * enable all error related interrupts        */
    SSP_SSP0IMSC = ( SSP_SSP0IMSC_RORIM_ENBL      // Enable overrun interrupt
                   | SSP_SSP0IMSC_RTIM_ENBL);     // Enable timeout interrupt
  
    /* Enable device and set it to master mode, no loopback */
    SSP_SSP0CR1 = SSP_SSP0CR1_SSE_ENABLED | SSP_SSP0CR1_MS_MASTER | SSP_SSP0CR1_LBM_NORMAL;
  }

  return;
}

/*----------------------------------------------------------*\
 | SSP Write Byte                                       |
\*----------------------------------------------------------*/
unsigned char  LCD_Access(unsigned char byte) {
  
   unsigned int Dummy;
  /* Wait if TNF cleared, Tx FIFO is full. */
  SSP_SSP0DR = byte;
  //SPDR=DATA;
 while (SSP_SSP0SR  & SSP_SSP0SR_BSY_BUSY);// while(!(SSPDR & SPIF)){}
   Dummy = SSP_SSP0DR; /* Flush the RxFIFO */
  return Dummy;
  }
/**************************************************************/
void  LCD_Init(void){
    
 // PINSEL1 &= ~0x000000FC;  // 
 // PINSEL1 |=  0x000000A8;  //   
  //PINSEL0 |=  0x5500; // SPI0

  GPIO_GPIO1DIR |= disp_CD_PIN | disp_Rs_PIN;  // CS/DC/RST
  //IO0CLR = (1<<17); // clk

  sspInit (0, 0, 0);

  Delay(300); 
  IO0CLR = disp_Rs_PIN;  Delay(75);
  IO0SET = LCD_CS_PIN;  Delay(75);
  IO0CLR = LCD_CLOCK_PIN;    Delay(75); 
  IO0SET = LCD_DC_PIN;    Delay(75); 
  IO0SET = LCD_RESET_PIN;    Delay(75); 

  LCD_SPI_DBCommand(&init_data[0], 2);  Delay(75); 
  LCD_SPI_DBCommand(&init_data[2], 10);  Delay(75); 
  LCD_SPI_DBCommand(&init_data[12], 23);   Delay(75);
  //IO0SET = LCD_CS_PIN;   

  }

// send word (16 bit) (or array with words) by SPI 
void LCD_SPI_DBCommand(const unsigned int data[], unsigned int count)
{  unsigned int  i;
  unsigned char lsbyte;
  unsigned char msbyte;

  for ( i=0; i<count; ++i)
  {
    IO0CLR = LCD_CS_PIN;            // CSelect := 0 
    IO0SET = LCD_DC_PIN;            // DataCmd := 1 
    msbyte = (data[i] >> 8) & 0xff;    // msb!
    lsbyte = data[i] & 0xff;      // lsb!  
     LCD_Access( msbyte );
      IO0SET = LCD_CS_PIN;
      IO0CLR = LCD_CS_PIN;  
     LCD_Access( lsbyte );
    IO0CLR = LCD_DC_PIN;            // DataCmd := 0 
    IO0SET = LCD_CS_PIN;
    
  }
}
void LCD_SPI_Byte(const unsigned char data[], unsigned int count) 
{  unsigned int i;
  //....data 
  for (i=0; i<count; ++i)  // Count Bytes 
  {
    LCD_Access( data[i] );
  } 
}

void LCD_SPI_Int(unsigned int Value) 
{ 
  
  IO0CLR = LCD_CS_PIN;
  LCD_Access( (Value >> 8) & 0xff);
/*  IO0SET = LCD_CS_PIN;
  IO0CLR = LCD_CS_PIN;    */
  LCD_Access( Value & 0xff);
  IO0SET = LCD_CS_PIN;
   
  
}
/***********************************************************************************************/
void LCD_Window(int x1, int y1, int x2, int y2) 
{ 
int x,y;
  
  
  IO0SET = LCD_DC_PIN;            // DataCmd := 1
  if(x1 < x2){ x = x2; x2 = x1; x1 = x;} // x2 muss größer sein als x1
  if(y2 < y1){ y = y1; y1 = y2; y2 = y;} // x2 muss größer sein als x1
  LCD_SPI_Int(0xEF80);    LCD_SPI_Int(0x1805    );
  LCD_SPI_Int(0x1200 + x1);  LCD_SPI_Int(0x1500 + x2);
  LCD_SPI_Int(0x1300 + y1);  LCD_SPI_Int(0x1600 + y2);   
  IO0CLR = LCD_DC_PIN;              // DataCmd := 0 
  
}                              
/***********************************************************************************************/  
 
void LCD_Cls(unsigned int color) 
{   unsigned int i;
  LCD_Window(0, 0, 131, 175);
  IO0CLR = LCD_DC_PIN;
  for (i=0; i<23232; ++i){  
  LCD_SPI_Int(color);
  } 
  IO0SET = LCD_DC_PIN;                                          // CSelect := 0 
}
/***********************************************************************************************/
void LCD_Plot(unsigned char x1, unsigned char y1, unsigned char line_type, unsigned int color)
{  unsigned char norm;
  if (line_type == norm)
  {
    LCD_Window(x1, y1, x1+1, y1+1);                   // Define Window, exactly four pixels large
    IO0CLR = LCD_DC_PIN;
    LCD_SPI_Int(color);                            // send four pixels (avoid loop overhead)
    LCD_SPI_Int(color);
    LCD_SPI_Int(color);
    LCD_SPI_Int(color);                                                    
    IO0SET = LCD_DC_PIN;
  }
  else
  {
  LCD_Window(x1, y1, x1, y1);                    // Define Window, exactly one pixel large
  IO0CLR = LCD_DC_PIN;
  LCD_SPI_Int(color);                          // send pixel                            
  IO0SET = LCD_DC_PIN;                
  }

}
/************************************************************************************************/


/*-----------------------------------------------------------------------------*\
 | LCD_RectangleFill  : Displays a rectangle filled                            |
\*-----------------------------------------------------------------------------*/
void LCD_RectangleFill( unsigned short x0, unsigned short y0, unsigned short x1, unsigned short y1, unsigned short Color ) {
  int x,y;

  LCD_Window(x0,y0,x1,y1);

  
  for(x=0;x<=x1-x0;x++)
    for(y=0;y<=y1-y0;y++)
    LCD_SPI_Int( Color );
  }
}  
/***********************************************************************
* writes a character to the lcd 
* put_char(10,10,"A",red,2); 
***********************************************************************/
/*
void put_char(unsigned char x, unsigned char y,  char *c, unsigned int textcolor,unsigned char rotation)
{
  unsigned int backcolor=0xFFFF;    // color of background
  unsigned char h,ch,p,mask;
  
     IO0CLR = LCD_CS_PIN;
  switch(rotation)
  {
    default:
    case 1:
    case 2:
      LCD_Window(x, y, (x+CharWidth-1), (y+CharHeight-1));
	   */
      /*lcd_comdat(y+CharHeight-1, y);
      lcd_wrcmd(0x17);
      lcd_comdat(x+CharWidth-1, x);
      lcd_wrcmd(0x21);
      lcd_comdat(x,y);
      lcd_wrcmd(0x22);
      spiSendByte(0x76); */
     
/*      break;
    case 3://
    case 4://
    LCD_Window(y,x, (y+CharHeight-1), (x+CharWidth-1));
	 */
     /* lcd_wrcmd(0x05);
      lcd_comdat(0x00,0x30);
      lcd_wrcmd(0x16);
      lcd_comdat(x+CharWidth-1, x);
      lcd_wrcmd(0x17);
      lcd_comdat(y+CharHeight-1, y);
      lcd_wrcmd(0x21);
      lcd_comdat(y,x);
      lcd_wrcmd(0x22);
      spiSendByte(0x76); */ 
/*
      break;
  }

  if (rotation==1||rotation==4){ 
    for (h=0; h<CharHeight; h++) // every column of the character
    {        
       if (rotation==1)
          ch = (int)ascii_tab[ *c-32 ][CharHeight-h-1];
       if (rotation==4)
          ch = (int)ascii_tab[ *c-32 ][h];  

        mask=0x80;
        for (p=0; p<CharWidth; p++)  // write the pixels
        {
          if (ch&mask)
          {
            LCD_SPI_Int(textcolor);                
          }
          else
          {
            LCD_SPI_Int(backcolor);
          }
          mask=mask/2;
        }
  }
}
  if (rotation==2){ // writes from left to right
    for (h=0; h<CharHeight; h++) // every column of the character
    {        
        ch = (int)(ascii_tab[ *c-32 ][h]);  
        mask=0x01;
        for (p=0; p<CharWidth; p++)  // write the pixels
        {
          if (ch&mask)
          {
            LCD_SPI_Int(textcolor);                
          }
          else
          {
            LCD_SPI_Int(backcolor);
          }
          mask=mask*2;
        }
  }
}
  if (rotation==3){
    for (h=CharHeight; h>0; h--) // every column of the character
    {        
        ch = (int)(ascii_tab[ *c-32 ][h]);  
        mask=0x01;
        for (p=0; p<CharWidth; p++)  // write the pixels
        {
          if (ch&mask)
          {
            LCD_SPI_Int(textcolor);                
          }
          else
          {
            LCD_SPI_Int(backcolor);
          }
          mask=mask*2;
        }
  }
}
   IO0SET = LCD_CS_PIN;
}
*/
/*-----------------------------------------------------------------------------*\
 | LCD_PutString  : Displays a string                                          |
\*-----------------------------------------------------------------------------*/
/*void LCD_PutString(unsigned short x, unsigned short y, char *s, unsigned int f, unsigned char rotation) {
   unsigned char l=0;
  while(*s) {
    
      put_char((x+l*8),y,(char *)s,f,rotation);
      s++;l++;
      }
  
    }
*/
